/* dispres - Dissociated Press
 *
 * Yet another garbagifier
 */

tdepth = 2;
twordqty = 100;

parse arg tdepth twordqty rest;

if tdepth < 1 then tdepth = 1;

trie. = 0;
trie.finalchar = D2C(C2D('Z')+1);
trie.initialchar = D2C(C2D('A')-1);
trie.depth = tdepth;
trie.wordqty = twordqty;

say "Depth" trie.depth ";" trie.wordqty "words";

do while lines() > 0
  l = linein();
  parse upper var l l;
  w = '';
  do i = 1 to length(l);
    c = substr(l,i,1);
    if datatype(c,'M') = 1 then do;
    	w = w||c;
    end;
    else do;
      call processword(w);
      w = '';
    end;
  end;
  call processword(w);
end;

say 'Analysis complete';

line = '';
do wordno = 1 to trie.wordqty;
	tmpword = right('',trie.depth,trie.initialchar);
	more = 1;
	position = 1;
	char = '';	
	do while(char\=trie.finalchar);
	  prefix = substr(tmpword,position,trie.depth);
	  n = trie.prefix.0;
	  if n = 0 then leave;
	  use = random(1,n);
	  sum = 0;
	  do charNo = C2D('A') to C2D('Z')+1 while sum<use;
	    char = D2C(charNo);
	    sum = sum + trie.prefix.char;
	  end;
	  if char\=trie.finalchar then do;
		  tmpword = tmpword || char;
		  position = position + 1;
		end;
	end;
	tmpword = substr(tmpword,trie.depth+1);
	if line = '' then do;
		line = tmpword;
	end;
	else if length(line)+1+length(tmpword) < 80 then do;
	  line = line tmpword;
	end;
	else do;
	  say line;
	  line = tmpword;
	end;
end;
say line;

return;

processword: procedure expose trie.
	parse upper arg w;

	if length(w)=0 then return;

	w = right(w,length(w)+trie.depth,trie.initialchar)||right('',trie.depth,trie.finalchar);
	do i = trie.depth+1 to length(w);
		prefix = substr(w,i-trie.depth,trie.depth);
		char = substr(w,i,1);
		trie.prefix.char = trie.prefix.char+1;
		trie.prefix.0 = trie.prefix.0+1;
	end;

return;

