/*
 * FORTUNE.CMD
 *
 * Picks and prints a fortune
 *
 * Reads from a file separating fortunes by lines starting with '%'
 */

parse arg ffile .;

ffile = STRIP(ffile);

if ffile='' then do;
  Say 'Usage: FORTUNE fortunefile';
  exit 8;
end;

fno = 0;
do while(LINES(ffile)>0)
  line=LINEIN(ffile);
  if SUBSTR(line,1,1)='%' then do;
    if fno>0 then do;
      fortune.fno.0 = lno-1;
    end;
    if lno>1 then do;
      /* Skip empty fortunes */
      fno = fno + 1;
      lno = 1;
    end;
  end;
  else if fno>0 then do;
    fortune.fno.lno = line;
    lno = lno + 1;
  end;
end;
if fno>0 then do;
  fortune.fno.0 = lno-1;
  fno = fno+1;
end;
fortune.0 = fno-1;

if fortune.0>0 then do;
  seed = SUBSTR(TIME('L'),4,2)||SUBSTR(TIME('L'),7,2)||SUBSTR(TIME('L'),10,2); /* Initialize random */
  fno = RANDOM(1,fortune.0,seed);
  do lno = 1 to fortune.fno.0;
    say fortune.fno.lno;
  end;
end;
else do;
  say 'Miss fortune'
end;

exit 0;


