/*
 * Extended DEL
 *
 * Improved DEL
 *
 * DEL Compatibility switches
 * /P: Prompt for delete Y/N
 * /N: Do not prompt when deleting an entire directory
 * /F: Delete with no UNDELETE allowed.
 *
 * New switches:
 * /R: Recurse subdirectories
 */

Parse arg argl;

  parse var argl filename switches;

  if filename = '' then do;
    say "USAGE: XDEL filename [switches]"
    exit;
  end;

  Recurse = '';
  Prompt  = 'N';
  Sanity  = 'Y';
  Undelete= '';

  do while switches \= '';
  	parse upper var switches switch switches;
  	select
  	  when switch='/R' then do;
  	  	Recurse = 'S';
  	 	end;
  	  when switch='/P' then do;
  	  	Prompt = 'Y';
  	 	end;
  	  when switch='/N' then do;
  	  	Sanity = 'N';
  	 	end;
  	  when switch='/F' then do;
  	  	Undelete = '/F';
  	 	end;
  		otherwise do;
  			say switch ": Unsupported switch";
  			exit;
  		end;
    end;
  end;

  /* Get utility funcs */
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs';
  call SysLoadFuncs;

  /* get file list */
  searchopts = 'T'Recurse;
  Rc = SysFileTree(filename,files,searchopts);

	cntfile = 0;
	cntdir  = 0;
	dirlist.= '';
	filelist.= '';
  if rc=0 then do;
    do i = 1 to files.0;
      parse var files.i fdatetime fsize fattr ffname;
      if SUBSTR(fattr,2,1)='D' then do;
      	cntdir = cntdir + 1;
      	dirlist.cntdir = ffname;
      end;
      else do;
      	cntfile = cntfile + 1;
      	filelist.cntfile = ffname;
      end;
    end;
    if Sanity='Y' Then Do;
      do until resp = 'Y' | resp = 'N' ;
      	Say "Delete" cntdir "directories and" cntfile "files. Proceed? (Y/N)";
        parse upper pull resp;
      end;
      if resp = 'Y' then
      	Sanity='N';
    end;
    else do;
    	Say "Deleting" cntdir "directories and" cntfile "files.";
    end;
    if Sanity='N' then do;
    	do i = 1 to cntfile;
    		"@DEL "Undelete" "filelist.i;
    	end;
    	do i = cntdir to 1 by -1;
    		"@RD "dirlist.i;
    	end;
    end;
  end;

  if Rc <> 0 then
    say 'Error: Rc='Rc;

exit;
