/*
 * Extended FIND
 *
 * find pattern in several files
 */

Parse arg argl;

  subFolders = '';
  suppressLines = 0;
  moreparms=1;
  do while(moreparms=1);
    parse upper var argl '/'parm rest;
    if parm='S' then do;
      subFolders='S';
      argl = rest;
    end;
    else if parm='X' then do;
      suppressLines=1;
      argl = rest;
    end;
    else do;
      moreparms=0;
    end;
  end;
  parse var argl filepattern searchpattern

  if filepattern = '' | searchpattern = '' then do;
    say "USAGE: XFIND [/S][/X] pattern searchpattern"
    say "       Options: /S: Recurse subdirectories"
    say "                /X: Suppress found lines"
    exit;
  end;

  XFINDTMP = "XFIND???.TMP";

  /* Get utility funcs */
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs';
  call SysLoadFuncs;

  /* get file list */

  Rc = SysFileTree(filepattern,files,'TF'Subfolders);

  if rc=0 then do;
    tmpfile = SysTempFileName(XFINDTMP);
    rc = LINEOUT(tmpfile,'');
    rc = STREAM(tmpfile,'C','CLOSE');
    do i = 1 to files.0;
      parse var files.i fdatetime fsize fattr ffname;
      '@FIND /I/N "'searchpattern'" 'ffname' >> 'tmpfile;
    end;
    line = LINEIN(tmpfile,1,0);
    do while (LINES(tmpfile)>0);
      line = LINEIN(tmpfile);
      parse var line '----------' fname;
      if fname\='' then do;
        infile = fname;
        said = 0;
      end;
      else if line\='' then do;
        if said=0 then do;
          if suppressLines=0 then say '';
          say infile;
          said=1;
        end;
        if suppressLines=0 then say line;
      end;
    end;
    rc = STREAM(tmpfile,'C','CLOSE');
    '@CALL DEL 'XFINDTMP;
  end;

  if Rc <> 0 then
    say 'Error: Rc='Rc;

exit;
